/*************************************************************
 * (C) 2001, Roberto A. Foglietta <robang@libero.it>
 *           Tutti i diritti riservati oppure GPL.
 *  
 * (C) 2001, Roberto A. Foglietta <robang@libero.it>
 *           Delivered under GPL as beta software,
 *           use at your own risk.
 *           
 * http://digilander.iol.it/robang
 *
 * rafobj.h : header per la gestione oggetti
 * creazione: 2001-04-25 
 * modifiche: 2001-05-28 v0.1 
 * 						2001-05-29 v0.1.1 BUG FIX & TESTED
 * 						2001-05-30 v0.1.2 some GET call SLT
 * 						2001-06-22 v0.1.3 Corrected get_nun in get_num
 * 						2001-07-01 v0.1.4 SLT | SET add as local method
 *						2001-07-03 v0.1.5 SORT with qsort function
 *						2001-07-05 v0.1.6 SLT | RPL metod as replacement of selected member
 */


#ifndef RAF_DEBUG
/*************************************************************
 * RAF 2001-05-04: debug msg system 
 *
 * Usage:
 * -	per attivare il debug in una funzione 
 * 		subito dopo le variaibli locali si definisce 
 * 		RAF_DEBUG_INIT{"nomefunc"};
 *
 * -	per disattivare il debug momentaneamente
 * 		RAF_DEBUG_INIT{"", "nomefunc"};
 *
 * ovviamente il debug e` attivabile/disattivabile
 * anche durante il run del programma agendo sul
 * primo puntatore di testo (NULL, oppure =secondo).
 * 		
 * -	per tracciare un msg di debug
 * 		RAF_DEBUG("text %parametrs", ...);
 *
 * -	per eseguire comandi solo in debug mode
 * 		RAF_DEBUG_EXEC {
 * 			comando_1;
 * 			...
 * 			comando_N;
 * 		}
 */
#ifndef g_print
#	define g_print printf
#else
#	define __GLIB__
#endif
#define RAF_DEBUG_FLAG 1
#define RAF_DEBUG_INIT static char * debug[] = 
#define RAF_DEBUG_EXEC if(RAF_DEBUG_FLAG && debug[0] && debug[0][0]) 
#define RAF_DEBUG	if(RAF_DEBUG_FLAG && debug[0] && debug[0][0])     \
										g_print("\nDEBUG %s: ", debug[0]);							\
									if(RAF_DEBUG_FLAG && debug[0] && debug[0][0]) 		\
										g_print
#ifndef __GLIB__
#	undef g_printf
#endif
#endif

#define RAF_OBJ_ADD 0xA0
#define RAF_OBJ_RMV 0xB0
#define RAF_OBJ_CPY 0xC0
#define RAF_OBJ_SLT 0x30
#define RAF_OBJ_GET 0x40
#define RAF_OBJ_ORD 0x50
#define RAF_OBJ_RPL 0x60
/* Metodo locale
#define RAF_SET     0x01 */
#define RAF_FIRST   0x02
#define RAF_PREV    0x03
#define RAF_NEXT    0x04
#define RAF_LAST    0x05
#define RAF_IND     0x06
#define RAF_NUM     0x07
#define RAF_COD     0x08
#define RAF_UNQ     0x09
#define RAF_FREEZE  0x0A
#define RAF_THAW    0x0B
#define RAF_ALL     0x0C
#define	raf_object_get_unq (    (long)raf_obj_manage(RAF_OBJ_GET | RAF_UNQ, NULL))
#define	raf_object_get_cod (    (long)raf_obj_manage(RAF_OBJ_GET | RAF_COD, NULL))
#define raf_object_get_ind ((unsigned)raf_obj_manage(RAF_OBJ_GET | RAF_IND, NULL))
#define raf_object_get_num ((unsigned)raf_obj_manage(RAF_OBJ_GET | RAF_NUM, NULL))

#define raf_object_get_slt(idx) ((RAF_TYPE_OBJECT *)raf_obj_manage(RAF_OBJ_SLT | idx, NULL))


const void *raf_obj_manage(int flag, void *pAram);


/* RAF 2001-05-28: TODO
 * Questi non saranno define ma init
 */
#ifndef RAF_MAX_NUM_OBJECT
#	define RAF_MAX_NUM_OBJECT  	1000
#endif

#ifndef RAF_TYPE_OBJECT
#	define RAF_TYPE_OBJECT    		struct card 	
#endif

#ifndef user_raf_obj_add
	void user_raf_obj_add(void);
#endif

